Index: code/trunk/src/modules/towerdefense/TowerDefenseCenterpoint.cc
===================================================================
--- code/trunk/src/modules/towerdefense/TowerDefenseCenterpoint.cc	(revision 10628)
+++ code/trunk/src/modules/towerdefense/TowerDefenseCenterpoint.cc	(revision 10629)
@@ -36,4 +36,5 @@
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
+#include "core/class/Super.h"
 
 #include "TowerDefense.h"
@@ -72,11 +73,15 @@
         XMLPortParam(TowerDefenseCenterpoint, "tileScale", setTileScale, getTileScale, xmlelement, mode);
         XMLPortParam(TowerDefenseCenterpoint, "selecterTemplate", setSelecterTemplate, getSelecterTemplate, xmlelement, mode);
-
-        //TODO: add XMLPortObject(TowerDefenseCenterpoint, WorldEntity, "waypoints", addWaypoint, getWaypoint,  xmlelement, mode);
-        // This was copied and shightly modified from WaypointController.cc ; there are no getters and setters and no membervariable yet
-        // The centerpoint should have all waypoints for "attached" to it. By using this function you can seperately add waypoints
-        // When you spawn a new enemy you should let it be controlled by a WaypointController. And that controller should get the waypoints.
-
-        // Alternatively you can manage the waypoints directly in TowerDefense.cc
+        XMLPortParam(TowerDefenseCenterpoint, "tower1Template", setTower1Template, getTower1Template, xmlelement, mode);
+        XMLPortParam(TowerDefenseCenterpoint, "tower2Template", setTower2Template, getTower2Template, xmlelement, mode);
+        XMLPortParam(TowerDefenseCenterpoint, "tower3Template", setTower3Template, getTower3Template, xmlelement, mode);
+        XMLPortParam(TowerDefenseCenterpoint, "tower4Template", setTower4Template, getTower4Template, xmlelement, mode);
+        XMLPortParam(TowerDefenseCenterpoint, "tower5Template", setTower5Template, getTower5Template, xmlelement, mode);
+        XMLPortParam(TowerDefenseCenterpoint, "fields", setFields, getFields, xmlelement, mode);
+        XMLPortParam(TowerDefenseCenterpoint, "tower1Cost", setTower1Cost, getTower1Cost, xmlelement, mode);
+        XMLPortParam(TowerDefenseCenterpoint, "tower2Cost", setTower2Cost, getTower2Cost, xmlelement, mode);
+        XMLPortParam(TowerDefenseCenterpoint, "tower3Cost", setTower3Cost, getTower3Cost, xmlelement, mode);
+        XMLPortParam(TowerDefenseCenterpoint, "tower4Cost", setTower4Cost, getTower4Cost, xmlelement, mode);
+        XMLPortParam(TowerDefenseCenterpoint, "tower5Cost", setTower5Cost, getTower5Cost, xmlelement, mode);
     }
 
@@ -94,3 +99,29 @@
         }
     }
+
+    /**
+    @brief
+        Removes all blanks, tabs and returns from the string passed.
+    */
+    void TowerDefenseCenterpoint::trimString(std::string* str)
+    {
+        std::string* trimmed = new std::string("");
+        int length = str->size();
+        char temp;
+        for (int i = 0; i < length; ++ i)
+        {
+            temp = str->at(i);
+            if (temp != ' ' && temp != '\t' && temp != '\n')
+            {
+                trimmed->push_back(temp);
+            }
+        }
+
+        *str = *trimmed;
+    }
+
+    const int TowerDefenseCenterpoint::getTowerCost(int upgrade) const
+    {
+        return towerCosts_[(upgrade%5)];
+    }
 }
Index: code/trunk/src/modules/towerdefense/TowerDefenseCenterpoint.h
===================================================================
--- code/trunk/src/modules/towerdefense/TowerDefenseCenterpoint.h	(revision 10628)
+++ code/trunk/src/modules/towerdefense/TowerDefenseCenterpoint.h	(revision 10629)
@@ -41,5 +41,5 @@
 #include <string>
 #include <util/Math.h>
-
+#include "TowerDefenseTower.h"
 #include "worldentities/MobileEntity.h"
 
@@ -65,8 +65,58 @@
             unsigned int getHeight(void) const
                 { return this->height_; }
+            void setFields(const std::string& newFields)
+                { this->fields_ = newFields; trimString(&fields_); }
+            const std::string& getFields() const
+                { return this->fields_; }                    
             void setSelecterTemplate(const std::string& newTemplate)
                 { this->selecterTemplate_ = newTemplate; }
             const std::string& getSelecterTemplate() const
                 { return this->selecterTemplate_; }   
+
+            void setTower1Template(const std::string& newTemplate)
+                { this->towerTemplates_[0] = newTemplate;}
+            const std::string& getTower1Template() const
+                { return this->towerTemplates_[0]; }  
+            void setTower2Template(const std::string& newTemplate)
+                { this->towerTemplates_[1] = newTemplate; }
+            const std::string& getTower2Template() const
+                { return this->towerTemplates_[1]; }
+            void setTower3Template(const std::string& newTemplate)
+                { this->towerTemplates_[2] = newTemplate; }
+            const std::string& getTower3Template() const
+                { return this->towerTemplates_[2]; } 
+            void setTower4Template(const std::string& newTemplate)
+                { this->towerTemplates_[3] = newTemplate; }
+            const std::string& getTower4Template() const
+                { return this->towerTemplates_[3]; }
+            void setTower5Template(const std::string& newTemplate)
+                { this->towerTemplates_[4] = newTemplate; }
+            const std::string& getTower5Template() const
+                { return this->towerTemplates_[4]; }  
+
+            void setTower1Cost(const int& newCost)
+                { this->towerCosts_[0] = newCost;}
+            const int& getTower1Cost() const
+                { return this->towerCosts_[0]; }  
+            void setTower2Cost(const int& newCost)
+                { this->towerCosts_[1] = newCost; }
+            const int& getTower2Cost() const
+                { return this->towerCosts_[1]; }
+            void setTower3Cost(const int& newCost)
+                { this->towerCosts_[2] = newCost; }
+            const int& getTower3Cost() const
+                { return this->towerCosts_[2]; } 
+            void setTower4Cost(const int& newCost)
+                { this->towerCosts_[3] = newCost; }
+            const int& getTower4Cost() const
+                { return this->towerCosts_[3]; }
+            void setTower5Cost(const int& newCost)
+                { this->towerCosts_[4] = newCost; }
+            const int& getTower5Cost() const
+                { return this->towerCosts_[4]; }
+
+            const int getTowerCost(int upgrade) const;
+                                            
+
             /**
                 @brief How to convert to world coordinates, e.g. that 0,15 is not at -8,-8 but at -80,-80 (if scale would be 10)
@@ -80,6 +130,9 @@
         private:
             void checkGametype();
-
+            void trimString(std::string*);
             std::string selecterTemplate_;
+            std::string towerTemplates_[5];
+            int towerCosts_[5];
+            std::string fields_;
             unsigned int width_;
             unsigned int height_;
Index: code/trunk/src/modules/towerdefense/TowerDefenseEnemy.cc
===================================================================
--- code/trunk/src/modules/towerdefense/TowerDefenseEnemy.cc	(revision 10628)
+++ code/trunk/src/modules/towerdefense/TowerDefenseEnemy.cc	(revision 10629)
@@ -30,28 +30,20 @@
         //needed to keep track of the PlayerStats coded in TowerDefense.h
         this->td = orxonox_cast<TowerDefense*>(this->getGametype());
-        once_=false;
+        once_ = false;
+    }
+
+    TowerDefenseEnemy::~TowerDefenseEnemy()
+    {
 
     }
-    //add credit if enemy is destroyed
-    TowerDefenseEnemy::~TowerDefenseEnemy(){
 
-    	if (this->isInitialized())
-    	{
-    		getGame()->addCredit(1);
-    	}
+    void TowerDefenseEnemy::tick(float dt)
+    {   
+        //orxout() << "TDE tick1" << endl;
+        SUPER(TowerDefenseEnemy, tick, dt);
+        //orxout() << "TDE tick2" << endl;
     }
 
-    void TowerDefenseEnemy::addWaypoint(TDCoordinate* coord)
-    {
-        this->Waypointsvector_.push_back(coord);
-    }
-
-
-    void TowerDefenseEnemy::tick(float dt)
-    {
-        SUPER(TowerDefenseEnemy, tick, dt);
-    }
-
-    TowerDefense* TowerDefenseEnemy::getGame()
+    WeakPtr<TowerDefense> TowerDefenseEnemy::getGame()
     {
         if (game == NULL)
@@ -63,37 +55,13 @@
     }
 
-    void TowerDefenseEnemy::damage(float damage, float healthdamage, float shielddamage, Pawn* originator, const btCollisionShape* cs)
+    void TowerDefenseEnemy::damage(float damage, float healthdamage, float shielddamage, Pawn* originator)
     {
-        Pawn::damage(damage, healthdamage, shielddamage, originator, cs);
+        Pawn::damage(damage, healthdamage, shielddamage, originator);
+        
         if (getGame() && once_ == false && getHealth() <= 0)
         {
-        	orxout() << "damagefunctionIF" << endl;
             getGame()->addCredit(1);
             once_ = true;
         }
-        orxout() << "damagefunction" << endl;
-
     }
-
-/*
-    void TowerDefenseEnemy::popWaypoint()
-    {
-        if(Waypointsvector_.size()>0)
-            Waypointsvector_.pop_back();
-    }
-
-    TDCoordinate TowerDefenseEnemy::peekWaypoint()
-    {
-        if(Waypointsvector_.size()<=0){
-            TDCoordinate* coord = TDCoordinate(-1,-1);
-            return coord;
-        }else{
-            return Waypointsvector_.at(Waypointsvector_.size()-1);
-
-        }
-
-
-    }
-*/
-
 }
Index: code/trunk/src/modules/towerdefense/TowerDefenseEnemy.h
===================================================================
--- code/trunk/src/modules/towerdefense/TowerDefenseEnemy.h	(revision 10628)
+++ code/trunk/src/modules/towerdefense/TowerDefenseEnemy.h	(revision 10629)
@@ -22,5 +22,4 @@
 #include "worldentities/pawns/SpaceShip.h"
 #include "util/Output.h"
-#include "controllers/ArtificialController.h"
 #include "TowerDefense.h"
 
@@ -39,18 +38,11 @@
 
         virtual void tick(float dt);
-        void addWaypoint(TDCoordinate* coord);
-        void popWaypoint();
-        TDCoordinate peekWaypoint();
-
-        virtual void damage(float damage, float healthdamage, float shielddamage, Pawn* originator, const btCollisionShape* cs);
-
+        virtual void damage(float damage, float healthdamage, float shielddamage, Pawn* originator);
 
     private:
-        TowerDefense* getGame();
+        WeakPtr<TowerDefense> getGame();
         WeakPtr<TowerDefense> game;
         TowerDefense* td;
         bool once_;
-        std::vector<TDCoordinate*> Waypointsvector_;
-
     };
 
Index: code/trunk/src/modules/towerdefense/TowerDefenseField.cc
===================================================================
--- code/trunk/src/modules/towerdefense/TowerDefenseField.cc	(revision 10629)
+++ code/trunk/src/modules/towerdefense/TowerDefenseField.cc	(revision 10629)
@@ -0,0 +1,327 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      ...
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file TowerDefenseField.cc
+    @brief Implementation of the TowerDefenseField class.
+*/
+
+#include "TowerDefenseField.h"
+#include "core/CoreIncludes.h"
+#include "core/XMLPort.h"
+#include "TowerDefense.h"
+
+namespace orxonox
+{
+    RegisterClass(TowerDefenseField);
+
+    /**
+    @brief
+        Constructor. Registers and initializes the object and checks whether the gametype is actually TowerDefense.
+    */
+    TowerDefenseField::TowerDefenseField(Context* context) : MovableEntity(context)
+    {
+        RegisterObject(TowerDefenseField);
+
+        tower_ = NULL;
+        type_ = FREE;
+        center_ = NULL;
+        upgrade_ = 0;
+        setPosition(0,0,0);                            
+        modelGround_ = new Model(getContext());
+        modelGround_->setScale(25);
+        modelGround_->pitch(Degree(90));
+        attach(modelGround_);
+        modelObject_ = new Model(getContext());
+        modelObject_->setScale(25);
+        modelObject_->pitch(Degree(90));
+        attach(modelObject_);
+        setAngle(0);
+    }
+
+    /**
+    @brief
+        Method to create a TowerDefenseField through XML.
+    */
+    void TowerDefenseField::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(TowerDefenseField, XMLPort, xmlelement, mode);
+
+        //XMLPortParam(TowerDefenseField, "width", setWidth, getWidth, xmlelement, mode);
+
+    }
+
+    void TowerDefenseField::setCenterpoint(TowerDefenseCenterpoint* center)
+    {
+        center_ = center;
+    }
+
+    void TowerDefenseField::upgrade()
+    {
+        if (canUpgrade() == true)
+        {
+            destroyTower();
+            createTower(getUpgrade() + 1);
+        }
+    }
+
+    int TowerDefenseField::getUpgrade()
+    {
+        return upgrade_;
+    }
+
+    TowerDefenseFieldType TowerDefenseField::getType()
+    {
+        return type_;
+    }
+
+    void TowerDefenseField::setUpgrade(int upgrade)
+    {
+        if (upgrade < 0)
+        {
+            upgrade_ = 0;
+        }   
+        else if (upgrade > 5)
+        {
+            upgrade = 5;
+        }
+        else
+        {
+            upgrade_ = upgrade;
+        }                            
+    }
+
+    bool TowerDefenseField::canUpgrade()
+    {
+        if (tower_ != NULL && upgrade_ < 5)
+        {
+            return true;
+        }
+
+        return false;
+    }
+
+    void TowerDefenseField::setAngle(int newAngle)
+    {
+        if (modelGround_ != NULL)
+        {
+            switch (newAngle)
+            {
+            case 0:
+                modelGround_->yaw(Degree(0));
+                angle_ = 0;
+                break;
+            case 1:
+                modelGround_->yaw(Degree(90));
+                angle_ = 1;
+                break;    
+            case 2:
+                modelGround_->yaw(Degree(180));
+                angle_ = 2;
+                break;   
+            case 3:
+                modelGround_->yaw(Degree(270));
+                angle_ = 3;
+                break;                                           
+            }
+        }
+
+        if (modelObject_ != NULL)
+        {
+            switch (newAngle)
+            {
+            case 0:
+                modelObject_->yaw(Degree(0));
+                angle_ = 0;
+                break;
+            case 1:
+                modelObject_->yaw(Degree(90));
+                angle_ = 1;
+                break;    
+            case 2:
+                modelObject_->yaw(Degree(180));
+                angle_ = 2;
+                break;   
+            case 3:
+                modelObject_->yaw(Degree(270));
+                angle_ = 3;
+                break;                                           
+            }
+        }
+        
+    }
+
+    int TowerDefenseField::getAngle()
+    {
+        return angle_;
+    }
+
+    void TowerDefenseField::createFree(int orientation)
+    {            
+        modelGround_->setMeshSource("TD_F1.mesh");
+        tower_ = NULL;
+        type_ = FREE;
+        setUpgrade(0);
+        setAngle(orientation);
+    }
+
+    void TowerDefenseField::createStart(int orientation)
+    {      
+        modelGround_->setMeshSource("TD_S5.mesh");
+        tower_ = NULL;
+        type_ = START;
+        setUpgrade(0);
+        setAngle(orientation);    
+    }
+
+
+    void TowerDefenseField::createEnd(int orientation)
+    {     
+        modelGround_->setMeshSource("TD_S4.mesh");
+        tower_ = NULL;
+        type_ = END;
+        setUpgrade(0);
+        setAngle(orientation);
+    }   
+
+    void TowerDefenseField::createStraight(int orientation)
+    {      
+        modelGround_->setMeshSource("TD_S1.mesh");
+        tower_ = NULL;
+        type_ = STREET;
+        setUpgrade(0);
+        setAngle(orientation);
+    }  
+
+    void TowerDefenseField::createRCurve(int orientation)
+    {     
+        modelGround_->setMeshSource("TD_S2.mesh");
+        tower_ = NULL;
+        type_ = STREET;
+        setUpgrade(0);
+        setAngle(orientation);
+    }  
+
+    void TowerDefenseField::createLCurve(int orientation)
+    {    
+        modelGround_->setMeshSource("TD_S3.mesh");
+        tower_ = NULL;
+        type_ = STREET;
+        setUpgrade(0);
+        setAngle(orientation);
+    } 
+
+    void TowerDefenseField::createObstacle(int orientation)
+    {    
+        modelGround_->setMeshSource("TD_F1.mesh");
+        modelObject_->setMeshSource("TD_O1.mesh");
+        tower_ = NULL;
+        type_ = OBSTACLE;
+        setUpgrade(0);
+        setAngle(orientation);
+    }
+
+    void TowerDefenseField::createTower(int upgrade)
+    {        
+        if (tower_ == NULL)
+        {
+            modelGround_->setMeshSource("TD_F1.mesh");
+            tower_ = new TowerDefenseTower(center_->getContext());
+            attach(tower_);
+            type_ = TOWER;
+            setUpgrade(upgrade);
+            if (upgrade_ > 0 && modelObject_ != NULL)
+            {
+                switch (upgrade_)
+                {
+                    case 1:
+                        modelObject_->setMeshSource("TD_T1.mesh");                    
+                        tower_->addTemplate(center_->getTower1Template());
+                        break;
+                    case 2:
+                        modelObject_->setMeshSource("TD_T2.mesh");
+                        tower_->addTemplate(center_->getTower2Template());
+                        break;
+                    case 3:
+                        modelObject_->setMeshSource("TD_T3.mesh");
+                        tower_->addTemplate(center_->getTower3Template());
+                        break;
+                    case 4:
+                        modelObject_->setMeshSource("TD_T4.mesh");
+                        tower_->addTemplate(center_->getTower4Template());
+                        break;
+                    case 5:
+                        modelObject_->setMeshSource("TD_T5.mesh");
+                        tower_->addTemplate(center_->getTower5Template());
+                        break;
+                }
+            }
+        }                           
+    }
+
+    void TowerDefenseField::destroyTower()
+    {
+        if (tower_ != NULL)
+        {
+            tower_->destroy();
+            tower_ = NULL;
+        }
+    }
+
+    void TowerDefenseField::create(char object, char param)
+    {
+        int paramInt = atoi(&param);
+        switch (object)
+        {
+            case 'F':
+                createFree(paramInt);
+                break;
+            case 'I':                
+                createStraight(paramInt);
+                break;
+            case 'R':                
+                createRCurve(paramInt);
+                break;  
+            case 'L':               
+                createLCurve(paramInt);
+                break;
+            case 'X':               
+                createStart(paramInt);
+                break;     
+            case 'O':               
+                createEnd(paramInt);
+                break;
+            case 'Y':               
+                createObstacle(paramInt);
+                break;                 
+            case 'T':                               
+                createTower(paramInt);               
+                break;                                                                                                         
+        }
+    }
+}
Index: code/trunk/src/modules/towerdefense/TowerDefenseField.h
===================================================================
--- code/trunk/src/modules/towerdefense/TowerDefenseField.h	(revision 10629)
+++ code/trunk/src/modules/towerdefense/TowerDefenseField.h	(revision 10629)
@@ -0,0 +1,97 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      ...
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+ @brief
+ See TowerDefenseReadme.txt for Information.
+ @ingroup TowerDefense
+ */
+
+
+#ifndef _TowerDefenseField_H__
+#define _TowerDefenseField_H__
+
+#include "towerdefense/TowerDefensePrereqs.h"
+#include "TowerDefenseTower.h"
+ #include "TowerDefenseCenterpoint.h"
+#include <string>
+#include "graphics/Model.h"
+#include "worldentities/MovableEntity.h"
+
+namespace orxonox
+{
+    enum TowerDefenseFieldType
+    { 
+        FREE,
+        STREET, 
+        START, 
+        END,
+        OBSTACLE,
+        TOWER
+    };
+
+
+    class _TowerDefenseExport TowerDefenseField : public MovableEntity
+    {
+        public:
+            TowerDefenseField(Context* context);
+            virtual ~TowerDefenseField() {}
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            const bool isFree() const
+                { return type_==FREE; }
+            virtual void create(char object, char param);
+            virtual void setCenterpoint(TowerDefenseCenterpoint* center);
+            virtual void upgrade();
+            virtual int getUpgrade();
+            virtual TowerDefenseFieldType getType();
+            virtual void setUpgrade(int upgrade);
+            virtual bool canUpgrade();
+            virtual void createFree(int orientation);
+            virtual void createStart(int orientation);
+            virtual void createEnd(int orientation);
+            virtual void createStraight(int orientation);
+            virtual void createLCurve(int orientation);
+            virtual void createRCurve(int orientation);
+            virtual void createObstacle(int orientation);
+            virtual void createTower(int upgrade);
+            virtual int getAngle();            
+        private:
+            virtual void setAngle(int newAngle);            
+            virtual void destroyTower();
+            int angle_;
+            TowerDefenseFieldType type_;
+            Model* modelGround_;
+            Model* modelObject_;
+            TowerDefenseTower* tower_;
+            TowerDefenseCenterpoint* center_;
+            int upgrade_;
+
+    };    
+}
+
+#endif /* _TowerDefenseField_H__ */
Index: code/trunk/src/modules/towerdefense/TowerDefenseHUDController.cc
===================================================================
--- code/trunk/src/modules/towerdefense/TowerDefenseHUDController.cc	(revision 10628)
+++ code/trunk/src/modules/towerdefense/TowerDefenseHUDController.cc	(revision 10629)
@@ -50,4 +50,5 @@
     {
         SUPER(TowerDefenseHUDController, tick, dt);
+
         const std::string& lifes = multi_cast<std::string>(this->td->getLifes());
         const std::string& credits = multi_cast<std::string>(this->td->getCredit());
@@ -55,11 +56,15 @@
 
         if(showlives == true)
-          this->setCaption(multi_cast<std::string>(lifes));
+        {
+            this->setCaption(multi_cast<std::string>(lifes));
+        }          
         else if(showcredits == true)
-          this->setCaption(multi_cast<std::string>(credits));
+        {
+            this->setCaption(multi_cast<std::string>(credits));
+        }          
         else if(showwaves == true)
-          this->setCaption(multi_cast<std::string>(wave));
-
-
+        {
+            this->setCaption(multi_cast<std::string>(wave));
+        }          
     }
 
Index: code/trunk/src/modules/towerdefense/TowerDefenseSelecter.cc
===================================================================
--- code/trunk/src/modules/towerdefense/TowerDefenseSelecter.cc	(revision 10628)
+++ code/trunk/src/modules/towerdefense/TowerDefenseSelecter.cc	(revision 10629)
@@ -51,7 +51,7 @@
         moveLeftPressed_ = false;
         moveRightPressed_ = false;
-        firePressed_ = false;
-        setSelectedPosition(6,6);
-        timerSetFire_=0;
+        boostPressed_ = false;
+        buildTower_ = false;
+        setSelectedPosition(0,0);     
     }
 
@@ -70,49 +70,44 @@
         SUPER(TowerDefenseSelecter, tick, dt);
 
+        time_ += dt;
 
-        if (hasLocalController())
-        {
-        	timerSetFire_ +=dt;
+        if (hasLocalController() && time_ >= 0.25)
+        {    
+            time_ = 0;
 
-        	if(timerSetFire_ >= 0.25)
-        	{
-        		timerSetFire_ = 0;
+            int selecterPosX = selectedPos_->GetX();
+            int selecterPosY = selectedPos_->GetY();
 
-        		int selecterPosX = selectedPos_->GetX();
-				int selecterPosY = selectedPos_->GetY();
-
-				if (moveUpPressed_ == true)
-				{
-					moveUpPressed_ = false;
-					selectedPos_->Set(selecterPosX, selecterPosY + 1);
-					updatePosition();
-				}
-				if (moveDownPressed_ == true)
-				{
-					moveDownPressed_ = false;
-					selectedPos_->Set(selecterPosX, selecterPosY - 1);
-					updatePosition();
-				}
-
-				if (moveLeftPressed_ == true)
-				{
-					moveLeftPressed_ = false;
-					selectedPos_->Set(selecterPosX - 1, selecterPosY);
-					updatePosition();
-				}
-				if (moveRightPressed_ == true)
-				{
-					moveRightPressed_ = false;
-					selectedPos_->Set(selecterPosX + 1, selecterPosY);
-					updatePosition();
-				}
-
-
-			}
-
-
-
-        }
-     }
+            if (moveUpPressed_ == true)
+            {                
+                moveUpPressed_ = false;
+                selectedPos_->Set(selecterPosX, selecterPosY + 1);
+                updatePosition();
+            }
+            if (moveDownPressed_ == true)
+            {
+                moveDownPressed_ = false;
+            	selectedPos_->Set(selecterPosX, selecterPosY - 1);
+                updatePosition();
+            }
+            if (moveLeftPressed_ == true)
+            {
+                moveLeftPressed_ = false;
+                selectedPos_->Set(selecterPosX - 1, selecterPosY);
+                updatePosition();
+            }
+            if (moveRightPressed_ == true)
+            {
+                moveRightPressed_ = false;
+            	selectedPos_->Set(selecterPosX + 1, selecterPosY);
+                updatePosition();
+            }
+            if (boostPressed_ == true)
+            {
+                boostPressed_ = false;
+                buildTower_ = true;
+            }
+        }         
+    }
 
 
@@ -157,11 +152,20 @@
     }
 
+    void TowerDefenseSelecter::fire(unsigned int firemode)
+    {
+    }
+
+    void TowerDefenseSelecter::fired(unsigned int firemode)
+    {
+        
+    }
 
     void TowerDefenseSelecter::boost(bool bBoost)
     {
-        firePressed_ = true;
-        orxout() << "boost" << endl;
+        if (bBoost == true)
+        {
+            boostPressed_ = true;
+        }
     }
-
 
     void TowerDefenseSelecter::updatePosition()
@@ -180,5 +184,3 @@
         setSelectedPosition(new TDCoordinate(x,y));
     }
-
-
 }
Index: code/trunk/src/modules/towerdefense/TowerDefenseSelecter.h
===================================================================
--- code/trunk/src/modules/towerdefense/TowerDefenseSelecter.h	(revision 10628)
+++ code/trunk/src/modules/towerdefense/TowerDefenseSelecter.h	(revision 10629)
@@ -48,18 +48,20 @@
             virtual void rotatePitch(const Vector2& value);
             virtual void rotateRoll(const Vector2& value);
+            void fire(unsigned int firemode);
+            virtual void fired(unsigned int firemode);
             virtual void boost(bool bBoost);
             virtual void setSelectedPosition(TDCoordinate* newPos);
             virtual void setSelectedPosition(int x, int y);
-            bool firePressed_;
+
+            bool buildTower_;
             TDCoordinate* selectedPos_;
-
-
         private:            
-            virtual void updatePosition();
-            float timerSetFire_;
+            virtual void updatePosition();                        
+            float time_;
             bool moveUpPressed_;
             bool moveDownPressed_;
             bool moveLeftPressed_;
-            bool moveRightPressed_;            
+            bool moveRightPressed_;                        
+            bool boostPressed_;            
     };
 }
Index: code/trunk/src/modules/towerdefense/TowerDefenseTower.cc
===================================================================
--- code/trunk/src/modules/towerdefense/TowerDefenseTower.cc	(revision 10628)
+++ code/trunk/src/modules/towerdefense/TowerDefenseTower.cc	(revision 10629)
@@ -27,9 +27,5 @@
         game_ =NULL;
         this->setCollisionType(WorldEntity::None);
-        upgrade = 0;
-        this->addTemplate("towerdefensetower");
-
-        upgradeMax = 5;
-
+        upgrade = 1;
 
         //this->removeAllEngines();
@@ -62,13 +58,13 @@
     bool TowerDefenseTower::upgradeTower()
     {
-        if(upgrade < upgradeMax)
+        if(upgrade < 5)
         {
             upgrade++;
             float reloadrate = getReloadRate();
             float reloadwaittime = getReloadWaitTime();
-            this->setDamageMultiplier((upgrade+1)*1.5f);
-            this->setRotationThrust(2*this->getRotationThrust());
-            reloadrate = 0.7f*reloadrate;
-            reloadwaittime = 0.7f*reloadwaittime;
+            this->setDamageMultiplier((upgrade+1)*2);
+            //this->setRotationThrust(2*this->getRotationThrust());
+            reloadrate = 0.5f*reloadrate;
+            reloadwaittime = 0.5f*reloadwaittime;
             setReloadRate(reloadrate);
             setReloadWaitTime(reloadwaittime);
